function z = lda_train(T1, T2)
% function lda_train compute the linear discriminate classifier for the
%   training data 
%   T n-by-m:       n feature, m samples.

S1 = cov(T1'); S2 = cov(T2');
m1 = mean(T1')'; m2 = mean(T2')';
Sw = S1 + S2; % within class
Sb = (m1-m2)*(m1-m2)';

%[V, E] = eig(Sb,Sw);
%[~,idx] = max(diag(E));
%z = V(:, idx); z = z/norm(z);
z = Sw\(m1-m2); z = z/norm(z);
