function [AA,TA] = evalG(z1, A, SIGA) 
%   function evalG evaluates the G(z1) matrix.

n = size(A,2);
m = size(A,1);
eA = -ones(m,1);

% Compute AA = G(z1)
for j = 1 : m
   S = SIGA(:,(j-1)*n+1:j*n);
   tp = S\z1(1:n);
   TA(j,:) = sign( -z1(end) + A(j,:)*z1(1:n) ) * tp.' / sqrt(z1(1:n)'*tp);
end
TA = A + TA;
AA= [TA,eA]'*[TA,eA];

return
