function [BB,TB] = evalH(z1, B, SIGB)
%   function evalG evaluates the H(z1) matrix.

n = size(B,2);
p = size(B,1);
eB = -ones(p,1);

% Compute BB = H(z1)
RB = []; TB = [];
for j = 1 : p
   S = SIGB(:,(j-1)*n+1:j*n);
   tp = S\z1(1:n);
   % check if S and hyperplane connected
   % i.e., sqrt(w' S^-1 w) < gamma + w^T a_i
   if ( sqrt(z1(1:n)'*tp) > abs(-z1(end)+B(j,:)*z1(1:n)) )
      % RB = [RB; B(j,:)];
      % TB = [TB; ( -B(j,:)*z1(1:n)+z1(end) ) * tp.' / (z1(1:n)'*tp)];
      continue;
   else
       RB = [RB; B(j,:)];
       TB = [TB; sign( -B(j,:)*z1(1:n)+z1(end) ) * tp.' / sqrt(z1(1:n)'*tp)];
   end
end

eB = -ones(size(TB,1),1); 
TB = RB + TB;
BB= [TB,eB]'*[TB,eB];

if length(TB) == 0
   error('Error: All class B ellipsoids intersects plane H(z)=0!')
end 

return
