function [AA, TG] = evalTG(z1, A, SIGA) 
%   function evalTG evaluates tilde G(z1) matrix.

[AA,TA] = evalG(z1, A, SIGA);
if nargout < 2, return; end

n = size(A,2);
m = size(A,1);
eA = -ones(m,1);

% Compute TG
Y = [TA,eA]*z1;
TG=[];
for jj = 1 : n
    ej = zeros(n,1); ej(jj) = 1;
    for j = 1 : m
        S = SIGA(:,(j-1)*n+1:j*n);
        tp = S\z1(1:n);
        TTA(j,:) = sign( -z1(end) + A(j,:)*z1(1:n) )/ sqrt(z1(1:n)'*tp)...
            * ( (S\ej)' - tp'*ej/(z1(1:n)'*tp)*tp' );
    end
    TG = [TG,[TTA,zeros(m,1)]'*Y];
end
TG = [TG,zeros(n+1,1)];
TG = 0.5*(TG+TG');

return
