function [BB, TH] = evalTH(z1, B, SIGB) 
%   function evalTH evaluates tilde H(z1) matrix.

[BB,TB] = evalH(z1, B, SIGB);
if nargout < 2, return; end

n = size(B,2);
p = size(B,1);
eB = -ones(size(TB,1),1);

% Compute TH
Y = [TB,eB]*z1;
TH=[];
for jj = 1 : n
    TTB=[];
    ej = zeros(n,1); ej(jj) = 1;
    for j = 1 : p
        S = SIGB(:,(j-1)*n+1:j*n);
        tp = S\z1(1:n);
        if ( sqrt(z1(1:n)'*tp) > abs(-z1(end)+B(j,:)*z1(1:n)) )
            % delete the column
            continue;
        end
        tt = sign( -B(j,:)*z1(1:n)+z1(end) )  / sqrt(z1(1:n)'*tp) ...
            * ( (S\ej)' - tp'*ej/(z1(1:n)'*tp)*tp' );
        TTB = [TTB; tt];
    end
    TH = [TH,[TTB,zeros(size(TTB,1),1)]'*Y];
end
TH = [TH,zeros(n+1,1)]; 
TH = 0.5*(TH+TH');
return
